import json

import requests
from requests.auth import HTTPBasicAuth
import json as js

secret_key = "secret_key"
oauthclientid = "oauthclientid"
token_url = "https://DOMAIN/oauth/token?grant_type=client_credentials"
tenant_url = "https://DOMAIN/"

s = requests.Session()
basicAuth = HTTPBasicAuth(oauthclientid, secret_key)
response = requests.get(token_url, auth=basicAuth)

access_token = response.json()["access_token"]
print(access_token)
s.headers.update({'Authorization': 'Bearer ' + access_token})
s.headers.update({'x-sap-sac-custom-auth': 'true'})
s.headers.update({'x-csrf-token': 'fetch'})


response = s.get(tenant_url + "api/v1/dataimport/models")
csrf_token = response.headers.get("x-csrf-token")
s.headers.update({'x-csrf-token': csrf_token})
print(csrf_token)


modelID = "modelID"
response = s.get(tenant_url + "api/v1/dataimport/models/"+modelID + "/metadata")
#print(response.json())


#create import job
response = s.post(tenant_url + "api/v1/dataimport/models/"+modelID+"/masterData")
#print(response.json())
jobID = response.json().get("jobID")

csvFile = open("localDimensionCSV.csv","r")
csvContent = csvFile.read()
csvFile.close()
s.headers.update({'content-type':'text/csv'})

response = s.post(tenant_url + "api/v1/dataimport/jobs/"+ jobID, data=csvContent)
print(response.json())

response = s.post(tenant_url + "api/v1/dataimport/jobs/"+ jobID + "/validate")
print(response.json())

response = s.post(tenant_url + "api/v1/dataimport/jobs/"+ jobID + "/run")
print(response.json())

response = s.delete(tenant_url + "api/v1/dataimport/jobs/"+ jobID)
print(response)